package musicrepos.mvc.controller;

import javax.servlet.RequestDispatcher;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import musicrepos.exception.UserNotLoggedException;
import musicrepos.mvc.model.Friendship;
import musicrepos.mvc.model.FriendshipDAO;
import musicrepos.mvc.model.User;
import musicrepos.mvc.model.UserDAO;

public class AddFriend implements BusinessLogic {

	@Override
	public void execute(HttpServletRequest request, HttpServletResponse response) throws Exception {
		User currentUser = (User) request.getSession().getAttribute("sessionUser");

		if (currentUser == null) {
			throw new UserNotLoggedException();
		}

		int userId = currentUser.getId();

		int friendId = Integer.parseInt(request.getParameter("id"));

		if (userId == friendId) {
			throw new Exception("You can't add yourself as a friend!");
		}

		UserDAO userDAO = new UserDAO();

		Friendship friendship = new Friendship();

		friendship.setUser(userDAO.getUser(userId));
		friendship.setFriend(userDAO.getUser(friendId));

		FriendshipDAO friendshipDAO = new FriendshipDAO();
		friendshipDAO.persist(friendship);

		RequestDispatcher rd = request.getRequestDispatcher("/ControllerServlet?action=ShowProfile&id=" + userId);
		rd.forward(request, response);
	}
}
