package musicrepos.mvc.controller;

import java.util.HashSet;
import java.util.List;
import java.util.Set;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import musicrepos.mvc.model.Music;
import musicrepos.mvc.model.MusicDAO;

public class BrowseMusic implements BusinessLogic {

	@Override
	public void execute(HttpServletRequest request, HttpServletResponse response) throws Exception {
		String startingLetter = request.getParameter("startingLetter");
		String artistName = request.getParameter("artist");
		String albumName = request.getParameter("album");

		List<Music> musics;
		MusicDAO musicDAO = new MusicDAO();

		if (startingLetter != null) {
			musics = musicDAO.getMusics("artist", startingLetter + "%");
			String xml = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" + "<artists>";
			if (musics.size() > 0) {
				Set<String> artists = new HashSet<String>();
				for (Music music : musics) {
					if (!artists.contains(music.getArtist())) {
						artists.add(music.getArtist());
						xml = xml + "<artist>" + music.getArtist() + "</artist>";
					}
				}
			}
			xml = xml + "</artists>";

			response.setContentType("text/xml");
			response.getWriter().println(xml);
		} else if (artistName != null && albumName == null) {
			musics = musicDAO.getMusics("artist", artistName);
			String xml = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" + "<albums>";
			if (musics.size() > 0) {
				Set<String> albums = new HashSet<String>();
				for (Music music : musics) {
					if (!albums.contains(music.getAlbum())) {
						albums.add(music.getAlbum());
						xml = xml + "<album>" + music.getAlbum() + "</album>";
					}
				}
			}
			xml = xml + "</albums>";

			response.setContentType("text/xml");
			response.getWriter().println(xml);

		} else if (artistName != null && albumName != null) {
			musics = musicDAO.getMusics("artist", artistName);
			String xml = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" + "<tracks>";
			if (musics.size() > 0) {
				for (Music music : musics) {
					if (music.getAlbum().equals(albumName)) {
						xml = xml + "<track>";
						xml = xml + "<trackId>" + music.getId() + "</trackId>";
						xml = xml + "<trackTitle>" + music.getTitle() + "</trackTitle>";
						xml = xml + "</track>";
					}
				}
			}
			xml = xml + "</tracks>";

			response.setContentType("text/xml");
			response.getWriter().println(xml);
		}
	}
}