package musicrepos.mvc.controller;

import javax.servlet.RequestDispatcher;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import musicrepos.mvc.model.Music;
import musicrepos.mvc.model.MusicDAO;
import musicrepos.util.FileSystemControl;
import musicrepos.util.Playlist;

public class PlayMusic implements BusinessLogic {

	@Override
	public void execute(HttpServletRequest request, HttpServletResponse response) throws Exception {
		String playlistDestination = FileSystemControl.getApplicationPath(request);
		playlistDestination = playlistDestination + "/player/temp2.xspf";

		System.out.println(playlistDestination);

		Playlist playlist = new Playlist(playlistDestination);
		playlist.createEmptyPlaylist();

		MusicDAO musicDAO = new MusicDAO();
		Music music = musicDAO.getMusic(Integer.parseInt(request.getParameter("id")));

		playlist.addSongs(new String[] { music.getPathname() });

		RequestDispatcher rd = request.getRequestDispatcher("/playMusic.jsp");
		rd.forward(request, response);
	}
}
