package musicrepos.mvc.controller;

import java.util.HashSet;
import java.util.List;
import java.util.Set;

import javax.servlet.RequestDispatcher;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import musicrepos.mvc.model.Music;
import musicrepos.mvc.model.MusicDAO;

public class SearchMusic implements BusinessLogic {

	@Override
	public void execute(HttpServletRequest request, HttpServletResponse response) throws Exception {
		MusicDAO musicDAO = new MusicDAO();

		String keyword = request.getParameter("music");

		Set<Music> result = new HashSet<Music>();

		List<Music> musics = musicDAO.getMusics("title", keyword);
		result.addAll(musics);

		musics = musicDAO.getMusics("artist", keyword);
		result.addAll(musics);

		musics = musicDAO.getMusics("album", keyword);
		result.addAll(musics);

		request.setAttribute("searchResult", result);

		RequestDispatcher rd = request.getRequestDispatcher("/searchResults.jsp");
		rd.forward(request, response);
	}
}
