package musicrepos.mvc.controller;

import java.util.List;

import javax.servlet.RequestDispatcher;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import musicrepos.mvc.model.FriendshipDAO;
import musicrepos.mvc.model.User;
import musicrepos.mvc.model.UserDAO;

public class ShowProfile implements BusinessLogic {

	@Override
	public void execute(HttpServletRequest request, HttpServletResponse response) throws Exception {
		int id;

		RequestDispatcher rd;

		try {
			id = Integer.parseInt(request.getParameter("id"));

			UserDAO dao = new UserDAO();
			User user = dao.getUser(id);
			request.setAttribute("user", user);

			FriendshipDAO friendshipDAO = new FriendshipDAO();
			List<User> userFriends = friendshipDAO.getUserFriends(user);
			request.setAttribute("userFriends", userFriends);

			rd = request.getRequestDispatcher("/userProfile.jsp");
		} catch (NumberFormatException nfe) {
			rd = request.getRequestDispatcher("/usersList.jsp");
		}

		rd.forward(request, response);
	}
}
