package musicrepos.mvc.controller;

import java.io.File;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

import javax.servlet.RequestDispatcher;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import musicrepos.exception.UserNotLoggedException;
import musicrepos.mvc.model.Music;
import musicrepos.mvc.model.User;
import musicrepos.util.MusicCreator;

import org.apache.commons.fileupload.FileItem;
import org.apache.commons.fileupload.FileItemFactory;
import org.apache.commons.fileupload.disk.DiskFileItemFactory;
import org.apache.commons.fileupload.servlet.ServletFileUpload;

import entagged.audioformats.AudioFile;
import entagged.audioformats.AudioFileIO;

public class UploadFile implements BusinessLogic {

	@SuppressWarnings("unchecked")
	@Override
	public void execute(HttpServletRequest request, HttpServletResponse response) throws Exception {
		User currentUser = (User) request.getSession().getAttribute("sessionUser");

		if (currentUser == null) {
			throw new UserNotLoggedException();
		}

		boolean isMultiPart = ServletFileUpload.isMultipartContent(request);

		if (!isMultiPart) {
			return;
		}

		FileItemFactory factory = new DiskFileItemFactory();
		ServletFileUpload upload = new ServletFileUpload(factory);

		List<FileItem> items = upload.parseRequest(request);
		Iterator<FileItem> iter = items.iterator();

		if (iter.hasNext()) {
			String pathname = currentUser.getId() + "_" + (new Date()).getTime() + ".mp3";

			FileItem item = iter.next();

			File file = new File(pathname);

			item.write(file);

			AudioFile audioFile = AudioFileIO.read(file);

			Music music = MusicCreator.createMusicFromTag(audioFile);
			music.setPathname(pathname);

			request.setAttribute("uploadedMusic", music);
		}

		RequestDispatcher rd = request.getRequestDispatcher("/tag.jsp");
		rd.forward(request, response);
	}

}
