package musicrepos.mvc.model;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import musicrepos.util.ConnectionFactory;

public class DAO {

	protected Connection connection;

	protected String tableName;

	DAO() {
		try {
			connection = ConnectionFactory.getConnection();
		} catch (SQLException e) {
			System.err.println("Unable to connect to the database");
			e.printStackTrace();
		}
	}

	public int countTableEntries() {
		int count = 0;

		PreparedStatement preparedStatement;

		try {
			preparedStatement = connection.prepareStatement("select count(*) from " + tableName);
			ResultSet counter = preparedStatement.executeQuery();

			if (counter.next()) {
				count = counter.getInt(1);
			}

		} catch (SQLException e) {
			count = 0;
		}

		return count;
	}

	protected void removeAllEntries() throws SQLException {
		PreparedStatement preparedStatement = connection.prepareStatement("delete from " + tableName);

		preparedStatement.execute();

		preparedStatement.close();
	}

	@Override
	protected void finalize() throws Throwable {
		if (connection != null) {
			connection.close();
		}

		super.finalize();
	}

}
