package musicrepos.mvc.model;

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

public class FriendshipDAO extends DAO {

	public FriendshipDAO() {
		super();

		tableName = "friendship";
	}

	public void persist(Friendship friendship) throws SQLException {
		String sql = "insert into friendship (user, friend) values (?,?)";

		PreparedStatement preparedStatement = connection.prepareStatement(sql);

		preparedStatement.setInt(1, friendship.getUser().getId());
		preparedStatement.setInt(2, friendship.getFriend().getId());

		preparedStatement.execute();
		preparedStatement.close();
	}

	public List<User> getUserFriends(User user) throws SQLException {
		PreparedStatement preparedStatement = connection.prepareStatement("select * from friendship where user = ?");

		preparedStatement.setInt(1, user.getId());

		ResultSet rs = preparedStatement.executeQuery();

		List<User> users = new ArrayList<User>();

		UserDAO userDAO = new UserDAO();

		while (rs.next()) {
			User friend = userDAO.getUser(rs.getInt("friend"));
			users.add(friend);
		}

		rs.close();
		preparedStatement.close();

		return users;
	}

}
