package musicrepos.mvc.model;

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

public class MusicDAO extends DAO {
	public MusicDAO() {
		super();

		tableName = "music";
	}

	public void persist(Music music) throws SQLException {
		String sql = "insert into music (title, artist, album, genre, year, pathname, userId) values (?,?,?,?,?,?,?)";

		PreparedStatement preparedStatement = connection.prepareStatement(sql);

		preparedStatement.setString(1, music.getTitle());
		preparedStatement.setString(2, music.getArtist());
		preparedStatement.setString(3, music.getAlbum());
		preparedStatement.setString(4, music.getGenre());
		preparedStatement.setInt(5, music.getYear());
		preparedStatement.setString(6, music.getPathname());
		preparedStatement.setInt(7, music.getUserId());

		preparedStatement.execute();
		preparedStatement.close();
	}

	public List<Music> getMusics(String field, String value) throws SQLException {
		String sql = "select * from music";
		if (field != null && value != null) {
			sql = sql + " where " + field + " like '" + value + "'";
		}

		PreparedStatement preparedStatement = connection.prepareStatement(sql);
		ResultSet rs = preparedStatement.executeQuery();

		List<Music> musics = new ArrayList<Music>();

		while (rs.next()) {
			Music music = new Music();
			music.setId(rs.getInt("id"));
			music.setTitle(rs.getString("title"));
			music.setArtist(rs.getString("artist"));
			music.setAlbum(rs.getString("album"));
			music.setGenre(rs.getString("genre"));
			music.setYear(rs.getInt("year"));
			music.setPathname(rs.getString("pathname"));
			music.setUserId(rs.getInt("userId"));
			musics.add(music);
		}

		rs.close();
		preparedStatement.close();
		return musics;
	}

	public Music getMusic(int id) throws SQLException {
		List<Music> musics = this.getMusics("id", Integer.toString(id));

		if (musics.size() == 1) {
			return musics.get(0);
		} else {
			return null;
		}
	}
}
