package musicrepos.util;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

import musicrepos.mvc.model.User;

public class Playlist {
	private String playlist;

	public Playlist(String filename) {
		playlist = filename;
	}

	public Playlist(int user_id, String user_login) {
		playlist = user_id + "_" + user_login + ".xspf";
	}

	public Playlist(User user) {
		this(user.getId(), user.getLogin());
	}

	public void printPlaylistName() {
		System.out.println(playlist);
	}

	public void createEmptyPlaylist() throws IOException {
		FileWriter outputStream = new FileWriter(playlist);

		BufferedWriter out = new BufferedWriter(outputStream);

		out.write("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
		out.newLine();

		out.write("<playlist version=\"1\" xmlns=\"http://xspf.org/ns/0/\">");
		out.newLine();

		out.write("<trackList>");
		out.newLine();

		out.write("</trackList>");
		out.newLine();

		out.write("</playlist>");
		out.newLine();

		out.close();
	}

	public void addSongs(String[] pathnames) throws IOException {
		FileReader inputStream = new FileReader(playlist);
		BufferedReader in = new BufferedReader(inputStream);

		FileWriter outputStream = new FileWriter("temp.xspf");
		BufferedWriter out = new BufferedWriter(outputStream);

		String line;

		while ((line = in.readLine()) != null) {
			if (line.equals("</trackList>")) {
				in.close();
				break;
			}
			out.write(line);
			out.newLine();
		}

		for (int i = 0; i < pathnames.length; i++) {
			out.write("<track><location>" + pathnames[i] + "</location></track>");
			out.newLine();
		}

		out.write("</trackList>");
		out.newLine();

		out.write("</playlist>");
		out.newLine();

		out.close();

		File file = new File(playlist);
		file.delete();

		File temp = new File("temp.xspf");
		temp.renameTo(new File(playlist));
	}
}
