create database sistemamusicrepository;

USE sistemamusicrepository;

CREATE TABLE `user` (
  `id` bigint(20) NOT NULL auto_increment,
  `login` varchar(255) NOT NULL,
  `name` text NOT NULL,
  `password` text NOT NULL,
  `email` text NOT NULL,
  `birthdate` date default NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `login` USING BTREE (`login`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=latin1;

CREATE TABLE `friendship` (
  `id` bigint(20) NOT NULL auto_increment,
  `user` bigint(20) NOT NULL,
  `friend` bigint(20) NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `user` (`user`,`friend`),
  KEY `chave2` (`friend`),
  CONSTRAINT `chave` FOREIGN KEY (`user`) REFERENCES `user` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `chave2` FOREIGN KEY (`friend`) REFERENCES `user` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=latin1 ROW_FORMAT=FIXED;

CREATE TABLE `music` (
  `id` int(11) NOT NULL auto_increment,
  `title` text NOT NULL,
  `artist` text,
  `album` text,
  `genre` text,
  `year` int(11) default NULL,
  `pathname` text NOT NULL,
  `userId` bigint(20) default NULL,
  PRIMARY KEY  (`id`),
  KEY `new_fk_constraint` (`userId`),
  CONSTRAINT `new_fk_constraint` FOREIGN KEY (`userId`) REFERENCES `user` (`id`) ON DELETE SET NULL ON UPDATE SET NULL
) ENGINE=InnoDB AUTO_INCREMENT=26 DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;
